// mcPolymer - Monte Carlo simulation program of radical polymerization
// Copyright (C) 2008 - 2021 Marco Drache, Georg Drache, Benjamin Hosemann, Katrin Brandl
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
/*
*
*  Created on: 3.9.2017
*/
#include <string>
#include <vector>

#include "parsing.h"

using namespace std;
namespace parsing {

vector<string> splitline(const string& _line) {
	vector<string> splitstring;
	const string SEP_CHAR = ",()[]=+<>";

	size_t pos;
	int start;
	string clearstring, substr, linecopy;
	bool sepmode;
	linecopy = _line;

	// separate +,(,),[,],=
	for (size_t i = 0; i < linecopy.length(); i++) {
		if (((linecopy.at(i) == ',') || linecopy.at(i) == '(') || (linecopy.at(i) == ')') || (linecopy.at(i) == '[') || (linecopy.at(i) == ']') || (linecopy.at(i) == '=') || (linecopy.at(i) == '>') || (linecopy.at(i) == '<')) {
			if (i < (linecopy.length() - 1)) {
				linecopy.insert(i + 1, " ");
			}
			else {
				linecopy.append(" ");
			}

			linecopy.insert(i, " ");
			++i;
			++i;
		}
	}
	// replace separators
	pos = linecopy.find_first_of(" \t:;,");
	while (pos != std::string::npos)
	{
		linecopy[pos] = ' ';
		pos = linecopy.find_first_of(" \t:;,", pos + 1);
	}
	start = 0;
	// ignore leading separators
	if (linecopy.at(0) == ' ') {
		for (size_t i = 0; i < linecopy.length(); i++) {
			if (linecopy.at(i) == ' ') {
				++start;
			}
			else {
				break;
			}
		}
	}
	// delete duplicate separators
	sepmode = false;
	substr = "";
	for (size_t i = start; i < linecopy.length(); i++) {
		if (linecopy.at(i) == ' ') {
			if (!sepmode) {
				sepmode = true;
				//close splitstring
				splitstring.push_back(substr);
				substr = "";
			}
		}
		else {
			substr.append(&linecopy.at(i), 1);
			sepmode = false;
		}
	}
	if (!sepmode) {
		if (substr != "") {
			splitstring.push_back(substr);
		}
	}

	return splitstring;
}

} // namespace
