// mcPolymer - Monte Carlo simulation program of radical polymerization
// Copyright (C) 2008 - 2021 Marco Drache, Georg Drache, Benjamin Hosemann, Katrin Brandl
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

/*
 * Connect.h
 *
 *  Created on: 28.04.2016
 */

#pragma once

#include <iostream>
#include <fstream>
#include <stdint.h>
#include "modelObjects.h"
#include "Fragment.h"

namespace mcPolymer_ns {

class Connect {
public:

	// Only used during file import
	Connect();
	Connect(Fragment *_c1, Fragment *_c2, ConnectType _type);

	// FIXME: Connect is copy-constructable and automatically created
	Connect(Connect *_Connect);
	~Connect();

	// FIXME: number should be an enum
	Fragment* getConnect(int _number) const;
	// FIXME: Maybe "getOtherConnect"?
	Fragment* getConnect12(const Fragment *_c) const;
	Fragment* getConnect1() const;
	Fragment* getConnect2() const;
	bool isConnected(Fragment *_c) const;
	// FIXME: getter/setter madness ahead, really necessary?
	ConnectType getType() const;
	// FIXME: number range?
	void setFragment(int _number, Fragment *_c);
	void setType(ConnectType _type);

private:
	Fragment *c1;
	Fragment *c2;
	ConnectType type;
};

} // namespace
