// mcPolymer - Monte Carlo simulation program of radical polymerization
// Copyright (C) 2008 - 2021 Marco Drache, Georg Drache, Benjamin Hosemann, Katrin Brandl
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
/*
* Reactor.cpp
*
*  Created on: 23.01.2019
*
*/
#include <fstream>
#include <iostream>
#include <math.h>
#include "Reactor.h"
#include "parsing.h"
#include "modelObjects.h"
#include "modelXML.h"

using namespace std;
namespace mcPolymer_ns {

Reactor::Reactor(reactorObject _reactorModel) {
	volume = _reactorModel.t0Volume;
	temperature = _reactorModel.temperature;
	pressure = _reactorModel.pressure;
}

} // namespace
