// mcPolymer - Monte Carlo simulation program of radical polymerization
// Copyright (C) 2008 - 2021 Marco Drache, Georg Drache, Benjamin Hosemann, Katrin Brandl
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
/*
 * Reactor.h
 *
 *  Created on: 23.01.2019
 *
 */
#include <vector>
#include <map>
#include "modelXML.h"
#include "modelObjects.h"
#pragma once

namespace mcPolymer_ns {

class Reactor {
public:
	Reactor(reactorObject _reactorModel);


private:
	const double AvogadroConstantNA = 6.022140857e23;

	// FIXME: temperature, pressure and molVolumeBalance are not being used anywhere
	double temperature;
	double pressure = 1.0;
	double volume = 1.0;
};

} // namespace
