// mcPolymer - Monte Carlo simulation program of radical polymerization
// Copyright (C) 2008 - 2021 Marco Drache, Georg Drache, Benjamin Hosemann, Katrin Brandl
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
/*
 *  Created on: 13.02.2021
 */

#pragma once

#include "cxxopts.hpp"
struct exportEvent {
	double time;
	bool exportConcentrations = false;
	bool exportCLD = false;
};
struct mcPolymerParameter {
	std::string modelFile_import = "";
	std::string modelFile_export = "";
	std::string outputdir = "mcPolymerSimulationResults";
	double reactionTime = 0.0;
	bool CmdlSetReactionTime = false;
	double dt = 0.0;
	bool CmdlSetdt = false;
	bool exportPolymers = false;
	double dtCLD = 0.0;
	bool CmdlSetdtCLD = false;
	bool CmdlSetdefinedCLDTimes = false;
	std::vector<double> definedCLDTimes;
	double temperature = 0.0;
	bool CmdlSetTemperature = false;
	bool ModelFileSetTemperature = false;
	double pressure = 1.0;
	bool CmdlSetPressure = false;
	uint64_t numMolecules = 0;
	bool CmdlSetnumMolecules = false;
	std::vector<exportEvent> timeline;

	// FIXME: check relative path of import file
	void setOutputPrefix() { modelFile_export = outputdir + "/" + modelFile_import; }
};

mcPolymerParameter parseCmdlineOptions(int argc, char* argv[]);
